import re


remove_letters ='[【|】]'
def remove_nouse_letters(text):
    '''
    删除一些无关的字符
    :param text:
    :return:
    '''
    clean_text = re.sub(remove_letters,"",text)
    return clean_text

punctuation = {
    '：':":",
    "，":",",
    '．':'.',
    "（":"(",
    "）":")",
    "－":"-"
}

def clean_html_whitesplace(text):
    text = text.replace("&nbsp;","")
    text = text.replace("&nbsp", "")
    text = text.replace(" ","")
    text = text.replace('\n',"")
    text = text.replace("\t","")
    text = text.replace(' ',"")
    text = text.replace(' ', "")
    text = text.replace("\u3000","")
    text = text.replace("\r", "")
    return text

def replace_punctuation(text):
    '''
    将中文标点符号替换成英文
    :param text:
    :return:
    '''
    for key,value in punctuation.items():
        text = text.replace(key,value)

    return text

def clean_punctuation(text):
    for key,value in punctuation.items():
        text = text.replace(key,"")

    return text



def clean_text(text):
    text = re.sub(r'\\r|\\n| ', '', text)
    text = remove_nouse_letters(text)
    text = clean_html_whitesplace(text)
    text = replace_punctuation(text)
    return text


def full_to_half(s):
    """
    Convert full-width character to half-width one
    """
    n = []
    for char in s:
        num = ord(char)
        if num == 0x3000:
            num = 32
        elif 0xFF01 <= num <= 0xFF5E:
            num -= 0xfee0
        char = chr(num)
        n.append(char)
    return ''.join(n)


def cut_to_sentence(text):
    """
    Cut text to sentences
    """
    sentence = []
    sentences = []
    len_p = len(text)
    pre_cut = False
    for idx, word in enumerate(text):
        sentence.append(word)
        cut = False
        if pre_cut:
            cut=True
            pre_cut=False
        if word in u"。;!?\n":
            cut = True
            if len_p > idx+1:
                if text[idx+1] in ".。”\"\'“”‘’?!":
                    cut = False
                    pre_cut=True

        if cut:
            sentences.append(sentence)
            sentence = []
    if sentence:
        sentences.append("".join(list(sentence)))
    return sentences


def replace_html(s):
    '''
    替换html里面的一些特殊标记符号
    '''
    s = s.replace('&quot;','"')
    s = s.replace('&amp;','&')
    s = s.replace('&lt;','<')
    s = s.replace('&gt;','>')
    s = s.replace('&nbsp;',' ')
    s = s.replace("&ldquo;", "“")
    s = s.replace("&rdquo;", "”")
    s = s.replace("&mdash;","")
    s = s.replace("\xa0", " ")
    return s

